## net.sf.saxon.instruct
Class ElementCreator

    java.lang.Object
      |
      +--net.sf.saxon.expr.ComputedExpression
            |
            +--net.sf.saxon.instruct.Instruction
                  |
                  +--net.sf.saxon.instruct.InstructionWithChildren
                        |
                        +--net.sf.saxon.instruct.ElementCreator

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

Direct Known Subclasses:
  Copy, Element, FixedElement

public abstract class ElementCreator
extends InstructionWithChildren

An instruction that creates an element node. There are two subtypes, FixedElement for use where the name is known statically, and Element where it is computed dynamically. To allow use in both XSLT and XQuery, the class acts both as an Instruction and as an Expression.

See Also:
  Serialized Form

Field Summary
`protected boolean` `inheritNamespaces` The inheritNamespaces flag indicates that the namespace nodes on the element created by this instruction are to be inherited (copied) on the children of this element.
`protected SchemaType` `schemaType`
`protected AttributeSet[]` `useAttributeSets`
`protected int` `validation`

Fields inherited from class net.sf.saxon.instruct.InstructionWithChildren
`children`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ElementCreator()`

Method Summary
`Item` `evaluateItem(XPathContext context)` Evaluate as an expression.
`int` `getCardinality()` Determine the static cardinality of the expression.
`ItemType` `getItemType()` Get the item type of the items returned by evaluating this instruction
`protected abstract int` `getNameCode(XPathContext context)`
`int` `getValidationMode()` Get the validation mode for the constructed element
`protected abstract void` `outputNamespaceNodes(XPathContext context, Receiver receiver)` Callback to output namespace nodes for the new element.
`TailCall` `processLeavingTail(XPathContext context)` Evaluate the instruction to produce a new element node
`void` `setValidationMode(int mode)` Set the validation mode for the new element

Methods inherited from class net.sf.saxon.instruct.InstructionWithChildren
`analyze, displayChildren, getChildren, iterateSubExpressions, processChildren, processChildrenLeavingTail, promoteInst, setChildren, simplify`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getImplementationMethod, getInstructionInfo, getInstructionNameCode, getSourceLocator, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, computeDependencies, computeStaticProperties, dynamicError, dynamicError, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Methods inherited from interface net.sf.saxon.expr.Expression
`display`

Field Detail

### useAttributeSets

    protected AttributeSet[] useAttributeSets

### schemaType

    protected SchemaType schemaType

### validation

    protected int validation

### inheritNamespaces

    protected boolean inheritNamespaces

  The inheritNamespaces flag indicates that the namespace nodes on the element created by this instruction are to be inherited (copied) on the children of this element. That is, if this flag is false, the child elements must carry a namespace undeclaration for all the namespaces on the parent, unless they are redeclared in some way.

Constructor Detail

### ElementCreator

    public ElementCreator()

Method Detail

### getItemType

    public ItemType getItemType()

  Description copied from class: `Instruction`
  Get the item type of the items returned by evaluating this instruction

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Instruction`
  Returns:
    the static item type of the instruction

### getCardinality

    public int getCardinality()

  Description copied from class: `ComputedExpression`
  Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `ComputedExpression`
  Returns:
    one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

### setValidationMode

    public void setValidationMode(int mode)

  Set the validation mode for the new element

### getValidationMode

    public int getValidationMode()

  Get the validation mode for the constructed element

### getNameCode

    protected abstract int getNameCode(XPathContext context)
                                throws XPathException

    `XPathException`

### outputNamespaceNodes

    protected abstract void outputNamespaceNodes(XPathContext context,
                                                 Receiver receiver)
                                          throws XPathException

  Callback to output namespace nodes for the new element.

  Parameters:
    `context` - The execution context
    `receiver` - the Receiver where the namespace nodes are to be written
  Throws:
    `XPathException`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Evaluate the instruction to produce a new element node

  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` -
  Returns:
    null (this instruction never returns a tail call)
  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an expression. We rely on the fact that when these instructions are generated by XQuery, there will always be a valueExpression to evaluate the content

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `Instruction`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression